#include "Game.h"
#include "FpsControl.h"

FpsControl::FpsControl() {
    lastTime = 0;
    tick = 0;
    fpsCnt = 0;
}

// FPS制御
void FpsControl::FpsWait() {
    nowTime = SDL_GetTicks();
    leftTime = lastTime + INTERVAL - nowTime;
    if (lastTime + INTERVAL > nowTime) {
        SDL_Delay(leftTime);
        lastTime = nowTime + leftTime;
    } else {
        lastTime = nowTime;
    }
    return;
}

// FPS表示
void FpsControl::FpsDisplay() {
    fpsCnt++;
    if (tick + 1000 < SDL_GetTicks()) {
        printf("%dFPS\n", fpsCnt);
        fpsCnt = 0;
        tick = SDL_GetTicks();
    }
    return;
}
