#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <SDL/SDL.h>
#include <SDL/SDL_draw.h>
#include <SDL/SDL_image.h>

#define HEIGHT      320
#define WIDTH       480
#define VIDEOBIT    24
#define FPS         60
#define INTERVAL    1000/FPS

#define UP      1000
#define DOWN    1001
#define LEFT    1002
#define RIGHT   1003

#define WALL    0x9b9b9b
#define BLACK   0x000000

// 背景星の数
#define STARNO  20

#define PLAYERHEIGHT   12
#define PLAYERWIDTH    12
#define ITEMSIZE       32
// アイテムの数
#define ITEMNO         3

class Game {
private:
    SDL_Surface *screen;    // スクリーン用メモリ
    SDL_Surface *image;     // MaterialImage
    SDL_PixelFormat *fmt;   // パレット情報
    int sdlInit;            // SDLInitの戻り値

    FILE *fp;               // ファイルポインタ
    char record[7];         // レコード読み込み用
    int recordANum;         // モードAのレコード
    int recordBNum;         // モードBのレコード
    int newFileFlg;         // レコードファイルを新規作成するかどうかのフラグ

    Uint32 backColor;       // 背景色
    Uint32 white;           // 白

    int i, j;               // ループ用

    int mode;               // モードA、モードB

    int dushFlg;            // ダッシュフラグ
    int dushCount;          // ダッシュゲージ溜まるスピード制御用
    int dushJudge;          // ダッシュゲージ溜まるスピード制御用
    int levelupCnt;         // レベルアップカウント、スコア
    int gameOverFlg;        // ゲームオーバーフラグ

    // タイトル文字描画用
    SDL_Rect titleSrc;
    SDL_Rect titleDsr;
    // タイトル透明度
    int titleAlpha;

    // タイトルのレコード描画用
    SDL_Rect aSrc;
    SDL_Rect aDsr;
    SDL_Rect bSrc;
    SDL_Rect bDsr;

    // Returnフラグ
    int returnFlg;

    // タイトルからのReturn制御
    int titleReturnFlg;

    // GAMEOVER文字描画用
    SDL_Rect overSrc;
    SDL_Rect overDsr;
    // GAMEOVER文字透明度
    int overAlpha;

    // RETRY描画用
    SDL_Rect retrySrc;
    SDL_Rect retryDsr;
    // TITLE描画用
    SDL_Rect titleKeySrc;
    SDL_Rect titleKeyDsr;
    // EXIT描画用
    SDL_Rect exitSrc;
    SDL_Rect exitDsr;
    
public:
    Game();
    ~Game();

    // 終了フラグ
    int endFlg;

    void Title();                   // タイトル画面
    int GameInit();                 // ゲーム初期化
    void GameMain(int *titleFlg);   // ゲーム本体
};