#include "Game.h"
#include "Info.h"

Info::Info() {
    iSrc.x = 102;
    iSrc.y = 0;
    iSrc.w = 104;
    iSrc.h = 64;
    iDsr.x = 10;
    iDsr.y = 0;

    ibSrc.x = 206;
    ibSrc.y = 0;
    ibSrc.w = 102;
    ibSrc.h = 51;
    ibDsr.x = 11;
    ibDsr.y = 12;

    dSrc.x = 12;
    dSrc.h = 8;
    dDsr.x = 16;
    dDsr.y = 47;

    nSrc.x = 0;
    nSrc.y = 64;
    nSrc.w = 12;
    nSrc.h = 10;

    lvDsr.x = 85;
    lvDsr.y = 30;

    pointDsr.x = 14;
    pointDsr.y = 15;

    lvGSrc.x = 12;
    lvGSrc.y = 0;
    lvGSrc.h = 8;
    lvGDsr.x = 16;
    lvGDsr.y = 31;

    rASrc.x = 308;
    rASrc.y = 0;
    rASrc.w = 165;
    rASrc.h = 15;
    rADsr.x = 29;
    rADsr.y = 227;
    rANumDsr.x = 41;
    rANumDsr.y = 232;

    rBSrc.x = 308;
    rBSrc.y = 15;
    rBSrc.w = 145;
    rBSrc.h = 15;
    rBDsr.x = 308;
    rBDsr.y = 227;
    rBNumDsr.x = 367;
    rBNumDsr.y = 232;

    nrNRSrc.x = 207;
    nrNRSrc.y = 52;
    nrNRSrc.w = 75;
    nrNRSrc.h = 10;
    nrNRDsr.x = 211;
    nrNRDsr.y = 51;

    nrKMSrc.x = 169;
    nrKMSrc.y = 15;
    nrKMSrc.w = 26;
    nrKMSrc.h = 10;
    nrKMDsr.x = 267;
    nrKMDsr.y = 66;

    nrNumDsr.x = 207;
    nrNumDsr.y = 66;

    nrAlpha = 0;
    nrAlphai = 15;

    dushGaugeLen = 0;
}

void Info::Draw(SDL_Surface* screen, SDL_Surface* image, int level, int levelupCnt, int mode) {
    // モードによって、ダッシュゲージの色が違う
    if (mode == 0) {
        dSrc.y = 8;
    } else if (mode == 1) {
        dSrc.y = 16;
    }
    // ダッシュゲージの長さ
    dSrc.w = dushGaugeLen;

    // レベルゲージ長さの計算
    lvGSrc.w = (float) (levelupCnt % 1000) / 1000.0 * 36.0;

    // 看板の背景
    SDL_SetAlpha(image, SDL_SRCALPHA, 150);
    SDL_BlitSurface(image, &ibSrc, screen, &ibDsr);
    // 看板
    SDL_SetAlpha(image, SDL_SRCALPHA, 255);
    SDL_BlitSurface(image, &iSrc, screen, &iDsr);
    // KM.数
    drawNumber5(screen, image, pointDsr.x, pointDsr, levelupCnt);
    // ダッシュゲージ
    SDL_BlitSurface(image, &dSrc, screen, &dDsr);
    // レベルゲージ
    SDL_BlitSurface(image, &lvGSrc, screen, &lvGDsr);
    // レベル数
    drawNumber2(screen, image, lvDsr.x, lvDsr, level);
}

void Info::titleRec(SDL_Surface *screen, SDL_Surface *image, int recordA, int recordB) {
    // モードAのレコード
    SDL_BlitSurface(image, &rASrc, screen, &rADsr);
    drawNumber5(screen, image, rANumDsr.x, rANumDsr, recordA);
    // モードBのレコード
    SDL_BlitSurface(image, &rBSrc, screen, &rBDsr);
    drawNumber5(screen, image, rBNumDsr.x, rBNumDsr, recordB);
}

void Info::RecDraw(SDL_Surface *screen, SDL_Surface *image, int record) {
    // 点滅処理
    nrAlpha += nrAlphai;
    if (nrAlpha >= 225) {
        nrAlphai = -nrAlphai;
    }
    if(nrAlpha <= 0){
        nrAlphai = -nrAlphai;
    }

    // NEWREC!
    SDL_SetAlpha(image, SDL_SRCALPHA, nrAlpha);
    SDL_BlitSurface(image, &nrNRSrc, screen, &nrNRDsr);
    // KM.
    SDL_SetAlpha(image, SDL_SRCALPHA, 225);
    drawNumber5(screen, image, nrNumDsr.x, nrNumDsr, record);
    SDL_BlitSurface(image, &nrKMSrc, screen, &nrKMDsr);
}

void Info::drawNumber2(SDL_Surface* screen, SDL_Surface* image, int x, SDL_Rect Dsr, int num) {
    int s, l, m;
    for (l = 10, m = 0; m < 2; l /= 10, m++) {
        s = num / l;
        Dsr.x = x + 12 * m;
        nSrc.x = s * 12;
        SDL_BlitSurface(image, &nSrc, screen, &Dsr);
        num %= l;
    }
}

void Info::drawNumber5(SDL_Surface* screen, SDL_Surface* image, int x, SDL_Rect Dsr, int num) {
    int s, l, m;
    for (l = 10000, m = 0; m < 5; l /= 10, m++) {
        s = num / l;
        Dsr.x = x + 12 * m;
        nSrc.x = s * 12;
        SDL_BlitSurface(image, &nSrc, screen, &Dsr);
        num %= l;
    }
}