#include "Game.h"
#include "Item.h"

Item::Item() {
    itemSrc.y = 24;
    itemSrc.w = ITEMSIZE;
    itemSrc.h = ITEMSIZE;

    // 移動量、斜め移動するため
    itemVx = 1;
    itemVy = 1;

    // アイテムの位置がランダムで
    itemDsr.x = rand() % (WIDTH - itemSrc.w);
    itemDsr.y = rand() % (HEIGHT - itemSrc.h);

    itemAlpha = 0;
}

void Item::Init() {
    // アイテムの位置がランダムで
    itemDsr.x = rand() % (WIDTH - itemSrc.w);
    itemDsr.y = rand() % (HEIGHT - itemSrc.h);
}

void Item::Draw(SDL_Surface* screen, SDL_Surface* image, int gameOverFlg, int mode) {
    // モードによって、アイテムの色が違う
    if (mode == 0) {
        itemSrc.x = 0;
    } else if (mode == 1) {
        itemSrc.x = 32;
    }

    // アイテム、フェードイン
    if (!gameOverFlg) {
        itemAlpha += 5;
        if (itemAlpha >= 255) {
            itemAlpha = 255;
        }
    }
    // GAMEOVER、アイテム、フェードアウト
    else if (gameOverFlg) {
        itemAlpha -= 5;
        if (itemAlpha <= 0) {
            itemAlpha = 0;
        }
    }
    // 描画
    SDL_SetAlpha(image, SDL_SRCALPHA, itemAlpha);
    SDL_BlitSurface(image, &itemSrc, screen, &itemDsr);
}

void Item::Move() {
    // バンド移動
    itemDsr.x += itemVx;
    itemDsr.y += itemVy;

    if (itemDsr.x >= WIDTH - itemSrc.w || itemDsr.x <= 0) {
        itemVx = -itemVx;
    }
    if (itemDsr.y >= HEIGHT - itemSrc.h || itemDsr.y <= 0) {
        itemVy = -itemVy;
    }
}