#include "Game.h"
#include "KeyState.h"

KeyState::KeyState() {
    keyFlg = 0x00;
}

// キー判定
void KeyState::Key(SDL_Event event, int *dushFlg, int gameOverFlg, int *returnFlg, int *endFlg, int *titleReturnFlg, int *mode) {
    while (SDL_PollEvent(&event)) {
        switch (event.type) {
            case SDL_KEYDOWN:
                switch (event.key.keysym.sym) {
                    case SDLK_UP:
                        if (gameOverFlg == 0) {
                            keyFlg = keyFlg | 0x01;
                        }
                        break;
                    case SDLK_DOWN:
                        if (gameOverFlg == 0) {
                            keyFlg = keyFlg | 0x02;
                        }
                        break;
                    case SDLK_LEFT:
                        if (gameOverFlg == 0) {
                            keyFlg = keyFlg | 0x04;
                        }
                        break;
                    case SDLK_RIGHT:
                        if (gameOverFlg == 0) {
                            keyFlg = keyFlg | 0x08;
                        }
                        break;
                    case SDLK_SPACE:
                        // ダッシュ
                        if (gameOverFlg == 0) {
                            *dushFlg = 1;
                        }
                        break;
                    case SDLK_a:
                        // タイトル、モードA
                        if (*titleReturnFlg == 0) {
                            *mode = 0;
                            *titleReturnFlg = 1;
                        }
                        break;
                    case SDLK_b:
                        // タイトル、モードB
                        if (*titleReturnFlg == 0) {
                            *mode = 1;
                            *titleReturnFlg = 1;
                        }
                        break;
                    case SDLK_r:
                        // GAMEOVER、RETRY
                        if (gameOverFlg == 1) {
                            *returnFlg = 1;
                        }
                        break;
                    case SDLK_t:
                        // TITLE
                        if (gameOverFlg == 1) {
                            *returnFlg = 2;
                        }
                        break;
                    case SDLK_e:
                        // EXIT
                        if (gameOverFlg == 1) {
                            *endFlg = 1;
                            *returnFlg = 1;
                        }
                        if (*titleReturnFlg == 0) {
                            *titleReturnFlg = 1;
                            *endFlg = 1;
                        }
                        break;
                    case SDLK_ESCAPE:
                        // EXIT
                        *endFlg = 1;
                        *titleReturnFlg = 1;
                        *returnFlg = 1;
                        break;
                }
                break;
            case SDL_KEYUP:
                switch (event.key.keysym.sym) {
                    case SDLK_UP: keyFlg = keyFlg & 0xfe;
                        break;
                    case SDLK_DOWN: keyFlg = keyFlg & 0xfd;
                        break;
                    case SDLK_LEFT: keyFlg = keyFlg & 0xfb;
                        break;
                    case SDLK_RIGHT: keyFlg = keyFlg & 0xf7;
                        break;
                    case SDLK_SPACE:
                        *dushFlg = 0;
                        break;
                }
                break;
            case SDL_QUIT:
                // 右上「×（ばつ）」ボタンによるEXIT
                *endFlg = 1;
                *titleReturnFlg = 1;
                *returnFlg = 1;
                break;
        }
    }
}